AdvancedAutoLootConfig                               = ZO_Object:Subclass()
AdvancedAutoLootConfig.db                            = nil
AdvancedAutoLootConfig.EVENT_TOGGLE_AUTOLOOT         = 'ADVANCEDAUTOLOOT_TOGGLE_AUTOLOOT'


local CBM = CALLBACK_MANAGER
local LAM = LibStub( 'LibAddonMenu-1.0' )
if ( not LAM ) then return end

function AdvancedAutoLootConfig:New( ... )
    local result = ZO_Object.New( self )
    result:Initialize( ... )
    return result
end

function AdvancedAutoLootConfig:Initialize( db )
    self.db = db
    self.config_panel = LAM:CreateControlPanel( '_advancedautoloot', 'Advanced AutoLoot' )

    LAM:AddHeader( self.config_panel, '_generalaloot', 'General' )
    LAM:AddCheckbox( self.config_panel, '_autolootactivated', 'Activate Loot filtering', 'Should we filter the looted items.',
        function() return self.db.autoLootActivated end, function() self:ToggleAutoLoot() end )
    LAM:AddSlider( self.config_panel, '_delay', 'Delay', 'Delay in milliseconds between mails(too short and you can be kicked from server)', 1500, 5000, 200,
        function() return self.db.delay end, function( delay ) self.db.delay = delay end )
    LAM:AddHeader( self.config_panel, '_autoloot', 'AutoLoot filters' )
	
	LAM:AddCheckbox( self.config_panel, '_keepProvisionning', 'Keep Provisionning ingredients', 'Should we keep the Provisionning ingredients.',
        function() return self.db.keepProvisionning end, function() self.db.keepProvisionning = not self.db.keepProvisionning end )
	LAM:AddCheckbox( self.config_panel, '_keepFood', 'Keep Food/Drinks', 'Should we keep Food/Drinks.',
        function() return self.db.keepFood end, function() self.db.keepFood = not self.db.keepFood end )
	LAM:AddCheckbox( self.config_panel, '_keepRecipes', 'Keep provisionning Recipes', 'Should we keep the Provisionning recipes (Epic or higher recipes will ALWAYS BE KEPT).',
        function() return self.db.keepRecipes end, function() self.db.keepRecipes = not self.db.keepRecipes end )
	LAM:AddCheckbox( self.config_panel, '_keepBaits', 'Keep Fishing baits', 'Should we keep the fishing baits.',
        function() return self.db.keepBaits end, function() self.db.keepBaits = not self.db.keepBaits end )
		
	LAM:AddCheckbox( self.config_panel, '_keepOrnate', 'Keep Ornate', 'Should we keep the Ornate(trait) items even if below quality treshold.',
        function() return self.db.keepOrnate end, function() self.db.keepOrnate = not self.db.keepOrnate end )
	LAM:AddCheckbox( self.config_panel, '_keepIntricate', 'Keep Intricate', 'Should we keep the Intricate(trait) items even if below quality treshold.',
        function() return self.db.keepIntricate end, function() self.db.keepIntricate = not self.db.keepIntricate end )
    LAM:AddSlider( self.config_panel, '_minQuality', 'Minimum quality to keep', 'Minimum quality below which items will be destroyed on loot(1 = white,5=legendary)', 1, 5, 1,
        function() return self.db.minQuality end, function( minQuality ) self.db.minQuality = minQuality end )
		
		
	-- Glyphs	
		
		
	LAM:AddHeader( self.config_panel, '_mailGlyph', 'Glyphs settings' )	
	LAM:AddCheckbox( self.config_panel, '_sendGlyph', 'Send Glyphs', 'Should we send Glyphs.',
        function() return self.db.mailSettings.Glyph.Send end, function() self.db.mailSettings.Glyph.Send = not self.db.mailSettings.Glyph.Send end )
	local gRecipEdit = LAM:AddEditBox(self.config_panel, '_glyphRecipient', 'Glyph recipient', 'Person to send the glyphs to.', false, function() return self.db.mailSettings.Glyph.To end,
		function(value) self.db.mailSettings.Glyph.To = value end)
	gRecipEdit.autoComplete = ZO_AutoComplete:New(gRecipEdit.edit, AUTO_COMPLETE_FLAG_ALL, AUTO_COMPLETION_ONLINE_OR_OFFLINE, MAX_AUTO_COMPLETION_RESULTS)
	LAM:AddEditBox(self.config_panel, '_glyphTopic', 'Glyph topic', 'Subject of the mail.', false, function() return self.db.mailSettings.Glyph.Subject end,
		function(value) self.db.mailSettings.Glyph.Subject = value end)
	LAM:AddCheckbox( self.config_panel, '_sendMatGlyph', 'Send materials', 'Should we send materials(ingots,planks etc...).',
		function() return self.db.mailSettings.Glyph.SendMaterials end, function() self.db.mailSettings.Glyph.SendMaterials = not self.db.mailSettings.Glyph.SendMaterials end )
	LAM:AddCheckbox( self.config_panel, '_sendGlyphBoosters', 'Send rune Boosters', 'Should we send runes that defines quality of glyph.',
        function() return self.db.mailSettings.Glyph.SendBoosters end, function() self.db.mailSettings.Glyph.SendBoosters = not self.db.mailSettings.Glyph.SendBoosters end )
    LAM:AddSlider( self.config_panel, '_glyphMin', 'Minimum items to send', 'Minimum number of items to send per mail', 1, 6, 1,
        function() return self.db.mailSettings.Glyph.MinNumber end, function( mini ) self.db.mailSettings.Glyph.MinNumber = mini end )
		
		
		
		
	LAM:AddHeader( self.config_panel, '_mailWood', 'Wood settings' )
	LAM:AddCheckbox( self.config_panel, '_sendWood', 'Send Wood items', 'Should we send wood items.',
        function() return self.db.mailSettings.Wood.Send end, function() self.db.mailSettings.Wood.Send = not self.db.mailSettings.Wood.Send end )
	local wRecipEdit = LAM:AddEditBox(self.config_panel, '_woodRecipient', 'Wood recipient', 'Person to send the wood items to.', false, function() return self.db.mailSettings.Wood.To end,
		function(value) self.db.mailSettings.Wood.To = value end)
	wRecipEdit.autoComplete = ZO_AutoComplete:New(wRecipEdit.edit, AUTO_COMPLETE_FLAG_ALL, AUTO_COMPLETION_ONLINE_OR_OFFLINE, MAX_AUTO_COMPLETION_RESULTS)
	LAM:AddEditBox(self.config_panel, '_woodTopic', 'Wood topic', 'Subject of the mail.', false, function() return self.db.mailSettings.Wood.Subject end,
		function(value) self.db.mailSettings.Wood.Subject = value end)
	LAM:AddCheckbox( self.config_panel, '_sendRawWood', 'Send raw components', 'Should we send raw components (leather scraps,ore etc...).',
		function() return self.db.mailSettings.Wood.SendRaw end, function() self.db.mailSettings.Wood.SendRaw = not self.db.mailSettings.Wood.SendRaw end )
	LAM:AddCheckbox( self.config_panel, '_sendMatWood', 'Send materials', 'Should we send materials(ingots,planks etc...).',
		function() return self.db.mailSettings.Wood.SendMaterials end, function() self.db.mailSettings.Wood.SendMaterials = not self.db.mailSettings.Wood.SendMaterials end )
	LAM:AddCheckbox( self.config_panel, '_sendBoosterWood', 'Send booster items', 'Should we send booster items(Pitch,Embroidery etc...).',
		function() return self.db.mailSettings.Wood.SendBoosters end, function() self.db.mailSettings.Wood.SendBoosters = not self.db.mailSettings.Wood.SendBoosters end )
	LAM:AddCheckbox( self.config_panel, '_sendWhiteWood', 'Send white items', 'Should we send white items.',
		function() return self.db.mailSettings.Wood.SendWhite end, function() self.db.mailSettings.Wood.SendWhite = not self.db.mailSettings.Wood.SendWhite end )
	LAM:AddCheckbox( self.config_panel, '_sendOrnateWood', 'Send ornate items', 'Should we send ornate items.',
		function() return self.db.mailSettings.Wood.SendOrnate end, function() self.db.mailSettings.Wood.SendOrnate = not self.db.mailSettings.Wood.SendOrnate end )
	LAM:AddCheckbox( self.config_panel, '_sendEquipmentWood', 'Send equipment items', 'Should we send equipment items.',
		function() return self.db.mailSettings.Wood.SendEquipment end, function() self.db.mailSettings.Wood.SendEquipment = not self.db.mailSettings.Wood.SendEquipment end )
	LAM:AddSlider( self.config_panel, '_WoodMaxQual', 'Maximum quality of items to send', 'Maximum quality of items to send (1=white,5=legendary)', 1, 5, 1,
		function() return self.db.mailSettings.Wood.MaxEquipment end, function( mini ) self.db.mailSettings.Wood.MaxEquipment = mini end )
	LAM:AddSlider( self.config_panel, '_woodMin', 'Minimum items to send', 'Minimum number of items to send per mail', 1, 6, 1,
	function() return self.db.mailSettings.Wood.MinNumber end, function( mini ) self.db.mailSettings.Wood.MinNumber = mini end )
	
		
		
		
		
		
	LAM:AddHeader( self.config_panel, '_mailCloth', 'Cloth settings' )
	LAM:AddCheckbox( self.config_panel, '_sendCloth', 'Send Cloth/Leather items', 'Should we send Cloth/Leather items.',
        function() return self.db.mailSettings.Cloth.Send end, function() self.db.mailSettings.Cloth.Send = not self.db.mailSettings.Cloth.Send end )
	local cRecipEdit = LAM:AddEditBox(self.config_panel, '_clothRecipient', 'Cloth/Leather recipient', 'Person to send the Cloth/Leather to.', false, function() return self.db.mailSettings.Cloth.To end,
		function(value) self.db.mailSettings.Cloth.To = value end)
	cRecipEdit.autoComplete = ZO_AutoComplete:New(cRecipEdit.edit, AUTO_COMPLETE_FLAG_ALL, AUTO_COMPLETION_ONLINE_OR_OFFLINE, MAX_AUTO_COMPLETION_RESULTS)
	LAM:AddEditBox(self.config_panel, '_clothTopic', 'Cloth/Leather topic', 'Subject of the mail.', false, function() return self.db.mailSettings.Cloth.Subject end,
		function(value) self.db.mailSettings.Cloth.Subject = value end)
	LAM:AddCheckbox( self.config_panel, '_sendRawCloth', 'Send raw components', 'Should we send raw components (leather scraps,ore etc...).',
		function() return self.db.mailSettings.Cloth.SendRaw end, function() self.db.mailSettings.Cloth.SendRaw = not self.db.mailSettings.Cloth.SendRaw end )
	LAM:AddCheckbox( self.config_panel, '_sendMatCloth', 'Send materials', 'Should we send materials(ingots,planks etc...).',
		function() return self.db.mailSettings.Cloth.SendMaterials end, function() self.db.mailSettings.Cloth.SendMaterials = not self.db.mailSettings.Cloth.SendMaterials end )
	LAM:AddCheckbox( self.config_panel, '_sendBoosterCloth', 'Send booster items', 'Should we send booster items(Pitch,Embroidery etc...).',
		function() return self.db.mailSettings.Cloth.SendBoosters end, function() self.db.mailSettings.Cloth.SendBoosters = not self.db.mailSettings.Cloth.SendBoosters end )
	LAM:AddCheckbox( self.config_panel, '_sendWhiteCloth', 'Send white items', 'Should we send white items.',
		function() return self.db.mailSettings.Cloth.SendWhite end, function() self.db.mailSettings.Cloth.SendWhite = not self.db.mailSettings.Cloth.SendWhite end )
	LAM:AddCheckbox( self.config_panel, '_sendOrnateCloth', 'Send ornate items', 'Should we send ornate items.',
		function() return self.db.mailSettings.Cloth.SendOrnate end, function() self.db.mailSettings.Cloth.SendOrnate = not self.db.mailSettings.Cloth.SendOrnate end )
	LAM:AddCheckbox( self.config_panel, '_sendEquipmentCloth', 'Send equipment items', 'Should we send equipment items.',
		function() return self.db.mailSettings.Cloth.SendEquipment end, function() self.db.mailSettings.Cloth.SendEquipment = not self.db.mailSettings.Cloth.SendEquipment end )
	LAM:AddSlider( self.config_panel, '_ClothMaxQual', 'Maximum quality of items to send', 'Maximum quality of items to send (1=white,5=legendary)', 1, 5, 1,
		function() return self.db.mailSettings.Cloth.MaxEquipment end, function( mini ) self.db.mailSettings.Cloth.MaxEquipment = mini end )
	LAM:AddSlider( self.config_panel, '_ClothMin', 'Minimum items to send', 'Minimum number of items to send per mail', 1, 6, 1,
	function() return self.db.mailSettings.Cloth.MinNumber end, function( mini ) self.db.mailSettings.Cloth.MinNumber = mini end )
		
		
		
		
	LAM:AddHeader( self.config_panel, '_mailMetal', 'Metal settings' )
	LAM:AddCheckbox( self.config_panel, '_sendMetal', 'Send Metal items', 'Should we send Metal items.',
        function() return self.db.mailSettings.Metal.Send end, function() self.db.mailSettings.Metal.Send = not self.db.mailSettings.Metal.Send end )
	local mRecipEdit = LAM:AddEditBox(self.config_panel, '_metalRecipient', 'Metal recipient', 'Person to send the metal items to.', false, function() return self.db.mailSettings.Metal.To end,
		function(value) self.db.mailSettings.Metal.To = value end)
	mRecipEdit.autoComplete = ZO_AutoComplete:New(mRecipEdit.edit, AUTO_COMPLETE_FLAG_ALL, AUTO_COMPLETION_ONLINE_OR_OFFLINE, MAX_AUTO_COMPLETION_RESULTS)
	LAM:AddEditBox(self.config_panel, '_metalTopic', 'Metal topic', 'Subject of the mail.', false, function() return self.db.mailSettings.Metal.Subject end,
		function(value) self.db.mailSettings.Metal.Subject = value end)
	LAM:AddCheckbox( self.config_panel, '_sendRawMetal', 'Send raw components', 'Should we send raw components (leather scraps,ore etc...).',
		function() return self.db.mailSettings.Metal.SendRaw end, function() self.db.mailSettings.Metal.SendRaw = not self.db.mailSettings.Metal.SendRaw end )
	LAM:AddCheckbox( self.config_panel, '_sendMatMetal', 'Send materials', 'Should we send materials(ingots,planks etc...).',
		function() return self.db.mailSettings.Metal.SendMaterials end, function() self.db.mailSettings.Metal.SendMaterials = not self.db.mailSettings.Metal.SendMaterials end )
	LAM:AddCheckbox( self.config_panel, '_sendBoosterMetal', 'Send booster items', 'Should we send booster items(Pitch,Embroidery etc...).',
		function() return self.db.mailSettings.Metal.SendBoosters end, function() self.db.mailSettings.Metal.SendBoosters = not self.db.mailSettings.Metal.SendBoosters end )
	LAM:AddCheckbox( self.config_panel, '_sendWhiteMetal', 'Send white items', 'Should we send white items.',
		function() return self.db.mailSettings.Metal.SendWhite end, function() self.db.mailSettings.Metal.SendWhite = not self.db.mailSettings.Metal.SendWhite end )
	LAM:AddCheckbox( self.config_panel, '_sendOrnateMetal', 'Send ornate items', 'Should we send ornate items.',
		function() return self.db.mailSettings.Metal.SendOrnate end, function() self.db.mailSettings.Metal.SendOrnate = not self.db.mailSettings.Metal.SendOrnate end )
	LAM:AddCheckbox( self.config_panel, '_sendEquipmentMetal', 'Send equipment items', 'Should we send equipment items.',
		function() return self.db.mailSettings.Metal.SendEquipment end, function() self.db.mailSettings.Metal.SendEquipment = not self.db.mailSettings.Metal.SendEquipment end )
	LAM:AddSlider( self.config_panel, '_MetalMaxQual', 'Maximum quality of items to send', 'Maximum quality of items to send (1=white,5=legendary)', 1, 5, 1,
		function() return self.db.mailSettings.Metal.MaxEquipment end, function( mini ) self.db.mailSettings.Metal.MaxEquipment = mini end )
	LAM:AddSlider( self.config_panel, '_MetalMin', 'Minimum items to send', 'Minimum number of items to send per mail', 1, 6, 1,
	function() return self.db.mailSettings.Metal.MinNumber end, function( mini ) self.db.mailSettings.Metal.MinNumber = mini end )		
		
		
		
		
	LAM:AddHeader( self.config_panel, '_mailFood', 'Food settings' )
	LAM:AddCheckbox( self.config_panel, '_sendProvisionning', 'Send Provisionning ingredients', 'Should we send Provisionning ingredients.',
        function() return self.db.mailSettings.Food.Send end, function() self.db.mailSettings.Food.Send = not self.db.mailSettings.Food.Send end )
	local pRecipEdit = LAM:AddEditBox(self.config_panel, '_provisionningRecipient', 'Provisionning recipient', 'Person to send the ingredients to.', false, function() return self.db.mailSettings.Food.To end,
		function(value) self.db.mailSettings.Food.To = value end)
	pRecipEdit.autoComplete = ZO_AutoComplete:New(pRecipEdit.edit, AUTO_COMPLETE_FLAG_ALL, AUTO_COMPLETION_ONLINE_OR_OFFLINE, MAX_AUTO_COMPLETION_RESULTS)
	LAM:AddEditBox(self.config_panel, '_provisionningTopic', 'Provisionning topic', 'Subject of the mail.', false, function() return self.db.mailSettings.Food.Subject end,
		function(value) self.db.mailSettings.Food.Subject = value end)
	LAM:AddCheckbox( self.config_panel, '_sendRecipes', 'Send Recipes', 'Should we send recipes.',
		function() return self.db.mailSettings.Food.SendRecipes end, function() self.db.mailSettings.Food.SendRecipes = not self.db.mailSettings.Food.SendRecipes end )
	LAM:AddSlider( self.config_panel, '_FoodMin', 'Minimum items to send', 'Minimum number of items to send per mail', 1, 6, 1,
		function() return self.db.mailSettings.Food.MinNumber end, function( mini ) self.db.mailSettings.Food.MinNumber = mini end )		
		
		
		
		
	LAM:AddHeader( self.config_panel, '_mailAlchemy', 'Alchemy settings' )
	LAM:AddCheckbox( self.config_panel, '_sendAlchemy', 'Send Alchemy ingredients', 'Should we send Alchemy ingredients.',
        function() return self.db.mailSettings.Alchemy.Send end, function() self.db.mailSettings.Alchemy.Send = not self.db.mailSettings.Alchemy.Send end )
	local aRecipEdit =LAM:AddEditBox(self.config_panel, '_alchemyRecipient', 'Alchemy recipient', 'Person to send the alchemy ingredients to.', false, function() return self.db.mailSettings.Alchemy.To end,
		function(value) self.db.mailSettings.Alchemy.To = value end)
	aRecipEdit.autoComplete = ZO_AutoComplete:New(aRecipEdit.edit, AUTO_COMPLETE_FLAG_ALL, AUTO_COMPLETION_ONLINE_OR_OFFLINE, MAX_AUTO_COMPLETION_RESULTS)
	LAM:AddEditBox(self.config_panel, '_alchemyTopic', 'Alchemy topic', 'Subject of the mail.', false, function() return self.db.mailSettings.Alchemy.Subject end,
		function(value) self.db.mailSettings.Alchemy.Subject = value end)
	LAM:AddSlider( self.config_panel, '_AlchemyMin', 'Minimum items to send', 'Minimum number of items to send per mail', 1, 6, 1,
	function() return self.db.mailSettings.Alchemy.MinNumber end, function( mini ) self.db.mailSettings.Alchemy.MinNumber = mini end )	
	
    
end

function AdvancedAutoLootConfig:ToggleAutoLoot()
    self.db.autoLootActivated = not self.db.autoLootActivated
    CBM:FireCallbacks( self.EVENT_TOGGLE_AUTOLOOT )
end
